searchNodes=[{"doc":"Integration with Auth0 to authorize m2m communication","ref":"BridgeEx.Auth0AuthorizationProvider.html","title":"BridgeEx.Auth0AuthorizationProvider","type":"module"},{"doc":"","ref":"BridgeEx.Auth0AuthorizationProvider.html#authorization_headers/1","title":"BridgeEx.Auth0AuthorizationProvider.authorization_headers/1","type":"function"},{"doc":"Preload a set of resources marking them as &quot;external&quot; and provide the related getter functions. Options resources (required): enumerable of resource names (atoms) and their paths (strings). Each path is assumed to be relative to the module directory. Examples defmodule MyBridge do use BridgeEx.Extensions.ExternalResources , resources : [ my_query : &quot;queries/query.graphql&quot; , my_mutation : &quot;mutations/mutation.graphql&quot; ] # it generates the following code: @external_resource &quot; \#{ __DIR__ } /queries/query.graphql&quot; @external_resource &quot; \#{ __DIR__ } /mutations/mutation.graphql&quot; @spec my_query ( ) :: String . t ( ) def my_query , do : Map . fetch! ( external_resources ( ) , :my_query ) @spec my_mutation ( ) :: String . t ( ) def my_mutation , do : Map . fetch! ( external_resources ( ) , :my_mutation ) defp external_resources do %{ my_query : &quot;contents of query.graphql&quot; , my_mutation : &quot;contents of mutation.graphql&quot; } end end","ref":"BridgeEx.Extensions.ExternalResources.html","title":"BridgeEx.Extensions.ExternalResources","type":"module"},{"doc":"Create a Graphql bridge in the given module. Once created, a graphql request can be made via MyBridge.call(&quot;my-query&quot;, %{&quot;variable&quot;: &quot;var&quot;}) Options endpoint (required): URL of the remote Graphql endpoint. auth0 : enable and configure Auth0 for authentication of requests. Takes the form of [enabled: false, audience: &quot;target-audience&quot;] . encode_variables : if true, encode the Graphql variables to JSON. Defaults to false . format_response : transforms camelCase keys in response to snake_case. Defaults to false . format_variables : transforms snake_case variable names to camelCase. Defaults to false . http_headers : HTTP headers for the request. Defaults to %{&quot;Content-type&quot;: &quot;application/json&quot;} . http_options : HTTP options to be passed to Telepoison. Defaults to [timeout: 1_000, recv_timeout: 16_000] . log_options : override global configuration for logging errors. Takes the form of [log_query_on_error: false, log_response_on_error: false] . max_attempts : number of times the request will be retried upon failure. Defaults to 1 . ⚠️ Deprecated: use retry_options instead. decode_keys : determines how JSON keys in GraphQL responses are decoded. Can be set to :atoms , :strings or :existing_atoms . Currently, the default mode is :atoms but will be changed to :strings in a future version of this library. You are highly encouraged to set this option to :strings to avoid memory leaks and security concerns . retry_options : override configuration regarding retries, namely delay : meaning depends on timing :constant : retry ever delay ms :exponential : start retrying with delay ms max_retries . Defaults to 0 policy : a function that takes an error as input and returns true / false to indicate whether to retry the error or not. Defaults to &quot;always retry&quot; ( fn _ -&gt; true end ). timing : either :exponential or :constant , indicates how frequently retries are made (e.g. every 1s, in an exponential manner and so on). Defaults to :exponential Examples defmodule MyBridge do use BridgeEx.Graphql , endpoint : &quot;http://my-api.com/graphql&quot; end defmodule MyBridge do use BridgeEx.Graphql , endpoint : &quot;http://my-api.com/graphql&quot; , auth0 : [ enabled : true , audience : &quot;target-audience&quot; ] end","ref":"BridgeEx.Graphql.html","title":"BridgeEx.Graphql","type":"module"},{"doc":"Graphql client for BridgeEx.","ref":"BridgeEx.Graphql.Client.html","title":"BridgeEx.Graphql.Client","type":"module"},{"doc":"Calls a GraphQL endpoint Parameters url : URL of the endpoint. query : Graphql query or mutation. variables : variables for Graphql query or mutation. opts : various options. Options options : extra HTTP options to be passed to Telepoison. headers : extra HTTP headers. encode_variables : whether to JSON encode variables or not. decode_keys : how JSON keys in GraphQL responses are decoded. Can be set to :strings (recommended), :atoms (discouraged due to security concerns - currently the default, but will be changed to :strings in a future version) or :existing_atoms (safer, but may crash the application if an unexpected key is received) retry_options : configures retry attempts. Takes the form of [max_retries: 1, timing: :exponential] log_options : configures logging on errors. Takes the form of [log_query_on_error: false, log_response_on_error: false] .","ref":"BridgeEx.Graphql.Client.html#call/4","title":"BridgeEx.Graphql.Client.call/4","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Client.html#t:bridge_response/0","title":"BridgeEx.Graphql.Client.bridge_response/0","type":"type"},{"doc":"Behaviour used to implement a formatter adapter which could be used to format types for both input variables and responses.","ref":"BridgeEx.Graphql.Formatter.Adapter.html","title":"BridgeEx.Graphql.Formatter.Adapter","type":"behaviour"},{"doc":"","ref":"BridgeEx.Graphql.Formatter.Adapter.html#c:format/1","title":"BridgeEx.Graphql.Formatter.Adapter.format/1","type":"callback"},{"doc":"Formatter to format map keys to camelCase.","ref":"BridgeEx.Graphql.Formatter.CamelCase.html","title":"BridgeEx.Graphql.Formatter.CamelCase","type":"module"},{"doc":"Callback implementation for BridgeEx.Graphql.Formatter.Adapter.format/1 .","ref":"BridgeEx.Graphql.Formatter.CamelCase.html#format/1","title":"BridgeEx.Graphql.Formatter.CamelCase.format/1","type":"function"},{"doc":"Formatter to format map keys to snake_case.","ref":"BridgeEx.Graphql.Formatter.SnakeCase.html","title":"BridgeEx.Graphql.Formatter.SnakeCase","type":"module"},{"doc":"Callback implementation for BridgeEx.Graphql.Formatter.Adapter.format/1 .","ref":"BridgeEx.Graphql.Formatter.SnakeCase.html#format/1","title":"BridgeEx.Graphql.Formatter.SnakeCase.format/1","type":"function"},{"doc":"This defines an adapter that supports GraphQL query documents in their conventional (in JS) camelCase notation, while allowing the schema to be defined using conventional (in Elixir) snake_case notation, and transforming the names as needed for lookups, results, and error messages. For example, this document: { myUser : createUser ( userId : 2 ) { firstName lastName } } Would map to an internal schema that used the following names: create_user instead of createUser user_id instead of userId first_name instead of firstName last_name instead of lastName Likewise, the result of executing this (camelCase) query document against our (snake_case) schema would have its names transformed back into camelcase on the way out: %{ data : %{ &quot;myUser&quot; =&gt; %{ &quot;firstName&quot; =&gt; &quot;Joe&quot; , &quot;lastName&quot; =&gt; &quot;Black&quot; } } } Note variables are a client-facing concern (they may be provided as parameters), so variable names should match the convention of the query document (eg, camelCase).","ref":"BridgeEx.Graphql.LanguageConventions.html","title":"BridgeEx.Graphql.LanguageConventions","type":"module"},{"doc":"Callback implementation for Absinthe.Adapter.to_external_name/2 .","ref":"BridgeEx.Graphql.LanguageConventions.html#to_external_name/2","title":"BridgeEx.Graphql.LanguageConventions.to_external_name/2","type":"function"},{"doc":"Converts a camelCase to snake_case iex&gt; to_internal_name(&quot;test&quot;, :read) &quot;test&quot; iex&gt; to_internal_name(&quot;testTTT&quot;, :read) &quot;test_t_t_t&quot; iex&gt; to_internal_name(&quot;testTest&quot;, :read) &quot;test_test&quot; iex&gt; to_internal_name(&quot;testTest1&quot;, :read) &quot;test_test_1&quot; iex&gt; to_internal_name(&quot;testTest11&quot;, :read) &quot;test_test_11&quot; iex&gt; to_internal_name(&quot;testTest11Pippo&quot;, :read) &quot;test_test_11_pippo&quot; iex&gt; to_internal_name(&quot;camelCase23Snake4344&quot;, :read) &quot;camel_case_23_snake_4344&quot;","ref":"BridgeEx.Graphql.LanguageConventions.html#to_internal_name/2","title":"BridgeEx.Graphql.LanguageConventions.to_internal_name/2","type":"function"},{"doc":"Utils for handling retrying of functions.","ref":"BridgeEx.Graphql.Retry.html","title":"BridgeEx.Graphql.Retry","type":"module"},{"doc":"","ref":"BridgeEx.Graphql.Retry.html#retry/3","title":"BridgeEx.Graphql.Retry.retry/3","type":"function"},{"doc":"Misc utils for handling Graphql requests/responses.","ref":"BridgeEx.Graphql.Utils.html","title":"BridgeEx.Graphql.Utils","type":"module"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#decode_http_response/4","title":"BridgeEx.Graphql.Utils.decode_http_response/4","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#parse_response/1","title":"BridgeEx.Graphql.Utils.parse_response/1","type":"function"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#t:client_response/0","title":"BridgeEx.Graphql.Utils.client_response/0","type":"type"},{"doc":"","ref":"BridgeEx.Graphql.Utils.html#t:graphql_response/0","title":"BridgeEx.Graphql.Utils.graphql_response/0","type":"type"},{"doc":"A simple counter for testing purposes.","ref":"BridgeEx.Utils.Counter.html","title":"BridgeEx.Utils.Counter","type":"module"},{"doc":"","ref":"BridgeEx.Utils.Counter.html#count/1","title":"BridgeEx.Utils.Counter.count/1","type":"function"},{"doc":"","ref":"BridgeEx.Utils.Counter.html#increment/1","title":"BridgeEx.Utils.Counter.increment/1","type":"function"},{"doc":"","ref":"BridgeEx.Utils.Counter.html#start/1","title":"BridgeEx.Utils.Counter.start/1","type":"function"},{"doc":"","ref":"BridgeEx.Utils.Counter.html#stop/1","title":"BridgeEx.Utils.Counter.stop/1","type":"function"},{"doc":"Copyright (c) 2020 Prima.it Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"A library to build bridges to GraphQL services.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Graphql Bridges to Graphql services are defined by use ing the BridgeEx.Graphql macro as follows: defmodule MyApp.SomeServiceBridge do use BridgeEx.Graphql , endpoint : &quot;http://some_service.example.com&quot; , decode_keys : :strings def my_query ( %{ } = variables ) do call ( &quot;a graphql query or mutation&quot; , variables , retry_policy : [ max_retries : 1 ] ) end end Besides endpoint and decode_keys , the following parameters can be optionally set when use ing BridgeEx.Graphql : auth0 encode_variables format_response format_variables http_headers http_options log_options max_attempts ⚠ Deprecated in favour of retry_options in call method The option decode_keys determines how JSON keys in GraphQL responses are decoded. If you don't provide it, it is set by default to :atoms , which is highly discouraged since it may raise security concerns (see &quot;Decoding keys to atoms&quot; in Jason documentation for more information). Other decoding modes are :strings and :existing_atoms which are safer. In a future version, this option will be set by default to :strings . Refer to the documentation for more details. If you need more control on your requests you can use BridgeEx.Graphql.Client.call directly. The library supports preloading queries from external files via the BridgeEx.Extensions.ExternalResources optional macro: defmodule MyApp.SomeServiceBridge do use BridgeEx.Graphql , endpoint : &quot;http://some_service.example.com&quot; , decode_keys : :strings use BridgeEx.Extensions.ExternalResources , resources : [ my_query : &quot;my_query.graphql&quot; ] def my_query ( %{ } = variables ) , do : call ( my_query ( ) , variables ) end Call options When call ing you can provide the following options, some of which override the ones provided when use ing the bridge: http_headers http_options retry_options Return values call can return one of the following values: {:ok, graphql_response} on success {:error, graphql_error} on graphql error (i.e. 200 status code but errors array is not nil ) {:error, {:bad_response, status_code}} on non 200 status code {:error, {:http_error, reason}} on http error e.g. :econnrefused Customizing the retry options By default if max_attempts is greater than 1 , the bridge retries every error regardless of its value (⚠ This way is deprecated). This behaviour can be customized by providing the retry_options to a call . retry_options : override configuration regarding retries, namely delay : meaning depends on timing :constant : retry ever delay ms :exponential : start retrying with delay ms max_retries . Defaults to 0 policy : a function that takes an error as input and returns true / false to indicate whether to retry the error or not. Defaults to &quot;always retry&quot; ( fn _ -&gt; true end ). timing : either :exponential or :constant , indicates how frequently retries are made (e.g. every 1s, in an exponential manner and so on). Defaults to :exponential A policy example: retry_policy = fn errors -&gt; case errors do { :bad_response , 400 } -&gt; true { :http_error , _reason } -&gt; true [ %{ message : &quot;some_error&quot; , extensions : %{ code : &quot;SOME_CODE&quot; } } ] -&gt; true _ -&gt; false end end defmodule BridgeWithCustomRetry do use BridgeEx.Graphql , endpoint : &quot;http://some_service.example.com/graphql&quot; , decode_keys : :strings end BridgeWithCustomRetry . call ( &quot;myquery&quot; , %{ } , retry_options : [ policy : retry_policy , max_retries : 2 ] ) (Deprecated) Global configuration The following configuration parameters can be set globally for all bridges in the app, by setting them inside your config.exs : config :bridge_ex, log_options: [log_query_on_error: true, log_response_on_error: false] to customize logging in your bridges Please note that this config has been deprecated since it's a footgun for umbrella apps and bad library design in general. Authenticating calls via Auth0 bridge_ex supports authentication of machine-to-machine calls via Auth0, through the prima_auth0_ex library. To use this feature do the following: update your config.exs with the necessary config to create API consumers with prima_auth0_ex , see the documentation add :prima_auth0_ex as a dependency in your mix project Then configure your bridge with the audience of the target service: use BridgeEx.Graphql , endpoint : &quot;...&quot; , decode_keys : :strings , auth0 : [ enabled : true , audience : &quot;target_audience&quot; ] Note that Auth0 integration must be explicitly enabled for each bridge where you want it by setting auth0: [enable: true] , as per the example above.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"As a good practice, if you want to mock your bridge for testing, you should define a behaviour: defmodule MyApp.SomeService do @callback my_cool_query ( any ( ) ) :: { :ok , map ( ) } | { :error , any ( ) } end Then implement it for your bridge: defmodule MyApp.SomeServiceBridge do @behaviour MyApp.SomeService use BridgeEx.Graphql , endpoint : &quot;...&quot; ... end And finally implement it again for the mock: defmodule MyApp.SomeServiceBridgeMock do @behaviour MyApp.SomeService alias BridgeEx.Graphql.Utils def my_cool_query ( %{ } = variables ) do File . read! ( &quot;some_mock_file.json&quot; ) |&gt; Json . decode! ( keys : :atoms ) # required to parse data |&gt; Utils . parse_response ( ) # optional, if you want to format the response # |&gt; BridgeEx.Graphql.Formatter.SnakeCase.format() end end You can now set the right module in your config/* directory: config :my_app , :some_service_bridge , MyApp.SomeServiceBridge # or config :my_app , :some_service_bridge , MyApp.SomeServiceBridgeMock And use it in your app from configuration: @some_service Application . compile_env! ( :my_app , :some_service_bridge ) # ... @some_service . my_cool_query ( %{ var : 2 } ) See example directory for an implementation, it also works in dev and test environments.","ref":"readme.html#testing-your-bridge","title":"Overview - Testing your bridge","type":"extras"},{"doc":"mix deps.get &amp;&amp; mix test","ref":"readme.html#development","title":"Overview - Development","type":"extras"},{"doc":"The package can be installed by adding bridge_ex to your list of dependencies in mix.exs : def deps do [ { :bridge_ex , &quot;~&gt; 2.0.0&quot; } # only if you want auth0 too # {:prima_auth0_ex, &quot;~&gt; 0.3.0&quot;} ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Copyright (c) 2020 Prima.it This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]